// import 'package:endlich/endlich.dart';
// import 'package:riverpod/riverpod.dart';
// import 'package:riverpod_endlich/riverpod_endlich.dart';

// extension XActiveStateRiverpod<State, Event>
//     on ActiveState<State, Object, Event> {
//   /// Nest an AutoDispose StateMachineProvider. The [provider] will automaitcally
//   /// be managed which means it will be immediately started and it will
//   /// be stopped when the active state is left.
//   /// [startWith] allows the machine to start in a different state than the default.
//   /// [onState] allows to listen so state changes in the [provider].
//   void nestAutoDisposeProvider<ChildStateValue, ChildEvent>(
//     AutoDisposeProviderRefBase ref,
//     AutoDisposeStateMachineProvider<ChildStateValue, ChildEvent> provider, {
//     ChildStateValue? startWith,
//     void Function(ChildStateValue stateValue)? onState,
//   }) {
//     if (!isActive) return;
//     nest(ref.read(provider.machine), startWith: startWith);

//     /// Listen to autoDispose provider so that it does not dispose
//     /// immediately. This will also prevent rebuilds of the parent
//     /// StateMachineProvider.
//     /// Let the provider dispose when leaving state.
//     ///
//     /// Will also call [onState]
//     onExit(ref.listen<MachineStatus<ChildStateValue, ChildEvent>>(
//       provider,
//       (status) {
//         if (null != onState) {
//           ref.read(provider.machine).state.maybeMap<void>(
//               orElse: () {}, running: (running) => onState(running.state));
//         }
//       },
//       fireImmediately: false,
//     ));

//     if (null != onState) {
//       ref.read(provider.machine).state.maybeMap<void>(
//           orElse: () {}, running: (running) => onState(running.state));
//     }
//   }

//   /// Nest an StateMachineProvider. The [provider] will automaitcally
//   /// be managed which means it will be immediately started and it will
//   /// be stopped when the active state is left.
//   /// [startWith] allows the machine to start in a different state than the default.
//   /// [onState] allows to listen so state changes in the [provider].
//   void nestProvider<ChildStateValue, ChildEvent>(
//     ProviderRefBase ref,
//     StateMachineProvider<ChildStateValue, ChildEvent> provider, {
//     ChildStateValue? startWith,
//     void Function(ChildStateValue stateValue)? onState,
//   }) {
//     if (!isActive) return;
//     nest(ref.read(provider.machine), startWith: startWith);

//     if (null != onState) {
//       onExit(ref.listen<MachineStatus<ChildStateValue, ChildEvent>>(
//         provider,
//         (status) {
//           status.maybeMap<void>(
//             orElse: () {},
//             running: (running) => onState.call(running.state),
//           );
//         },
//         fireImmediately: false,
//       ));

//       ref.read(provider.machine).state.maybeMap<void>(
//             orElse: () {},
//             running: (running) => onState.call(running.state),
//           );
//     }
//   }
// }
